// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Primary design header
//
// This header should be included by all source files instantiating the design.
// The class here is then constructed to instantiate the design.
// See the Verilator manual for examples.

#ifndef _VTWE_H_
#define _VTWE_H_  // guard

#include "verilated_heavy.h"
#include "verilated_cov.h"

//==========

class VTWE__Syms;
class VTWE_VerilatedVcd;


//----------

VL_MODULE(VTWE) {
  public:
    
    // PORTS
    // The application code writes and reads these signals to
    // propagate new values into/out from the Verilated model.
    VL_IN8(clk,0,0);
    VL_IN8(res_n,0,0);
    VL_IN8(lock,0,0);
    VL_IN8(unlock,0,0);
    VL_IN8(virt_addr_in_vld,0,0);
    VL_IN8(data_from_memory_vld,0,0);
    VL_IN8(mode,1,0);
    VL_OUT8(locked,0,0);
    VL_OUT8(phys_addr_out_vld,0,0);
    VL_OUT8(data_to_memory_vld,0,0);
    VL_OUT8(twe_active,0,0);
    VL_IN16(key,15,0);
    VL_IN64(virt_addr_in,47,0);
    VL_IN64(data_from_memory,39,0);
    VL_IN64(pte_root_addr,47,0);
    VL_OUT64(phys_addr_out,47,0);
    VL_OUT64(data_to_memory,47,0);
    
    // LOCAL SIGNALS
    // Internals; generally not touched by application code
    CData/*2:0*/ TWE__DOT__STATE;
    CData/*2:0*/ TWE__DOT__NEXT_STATE;
    CData/*0:0*/ TWE__DOT__VA48_CAM_hit;
    CData/*0:0*/ TWE__DOT__ras_out_addr_val_int;
    CData/*0:0*/ TWE__DOT__ras_locked_int;
    CData/*0:0*/ TWE__DOT__ras_write_active_int;
    CData/*0:0*/ TWE__DOT__ras_empty_int;
    CData/*0:0*/ TWE__DOT__ras_full_int;
    CData/*0:0*/ TWE__DOT__DO_IDLE;
    CData/*0:0*/ TWE__DOT__DO_LOCK;
    CData/*0:0*/ TWE__DOT__DO_UNLOCK;
    CData/*0:0*/ TWE__DOT__IS_TLB_HIT;
    CData/*0:0*/ TWE__DOT__NEXT_LEVEL;
    CData/*0:0*/ TWE__DOT__START_TWE;
    CData/*0:0*/ TWE__DOT__VA48_CAM_rd;
    CData/*0:0*/ TWE__DOT__VA48_CAM_wr;
    CData/*3:0*/ TWE__DOT__VA48_CAM__DOT__HEAD;
    CData/*3:0*/ TWE__DOT__VA48_CAM__DOT__HEAD_PLUS_1;
    CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT__STATE;
    CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT__NEXT_STATE;
    CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_status;
    CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_wr;
    CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_rd;
    CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_empty;
    CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_full;
    CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT__DO_IDLE;
    CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT__DO_LOCK;
    CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT__DO_UNLOCK;
    CData/*3:0*/ TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__HEAD;
    CData/*3:0*/ TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__HEAD_PLUS_1;
    CData/*3:0*/ TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__HEAD_MINUS_1;
    SData/*15:0*/ TWE__DOT__VA48_CAM__DOT__compare;
    WData/*71:0*/ TWE__DOT__data_from_tlb[3];
    WData/*71:0*/ TWE__DOT__VA48_CAM_rd_data[3];
    WData/*71:0*/ TWE__DOT__VA48_CAM_wr_data[3];
    IData/*31:0*/ TWE__DOT__VA48_CAM__DOT__unnamedblk1__DOT__i;
    IData/*31:0*/ TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__i;
    QData/*47:0*/ TWE__DOT__ras_out_addr_int;
    QData/*47:0*/ TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_wr_data;
    QData/*47:0*/ TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_rd_data;
    WData/*71:0*/ TWE__DOT__VA48_CAM__DOT__MEMORY[16][3];
    QData/*47:0*/ TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[16];
    
    // LOCAL VARIABLES
    // Internals; generally not touched by application code
    // Anonymous structures to workaround compiler member-count bugs
    struct {
        CData/*0:0*/ TWE__DOT____Vtogcov__clk;
        CData/*0:0*/ TWE__DOT____Vtogcov__res_n;
        CData/*0:0*/ TWE__DOT____Vtogcov__lock;
        CData/*0:0*/ TWE__DOT____Vtogcov__unlock;
        CData/*0:0*/ TWE__DOT____Vtogcov__virt_addr_in_vld;
        CData/*0:0*/ TWE__DOT____Vtogcov__data_from_memory_vld;
        CData/*1:0*/ TWE__DOT____Vtogcov__mode;
        CData/*0:0*/ TWE__DOT____Vtogcov__locked;
        CData/*0:0*/ TWE__DOT____Vtogcov__phys_addr_out_vld;
        CData/*0:0*/ TWE__DOT____Vtogcov__data_to_memory_vld;
        CData/*0:0*/ TWE__DOT____Vtogcov__twe_active;
        CData/*2:0*/ TWE__DOT____Vtogcov__STATE;
        CData/*2:0*/ TWE__DOT____Vtogcov__NEXT_STATE;
        CData/*0:0*/ TWE__DOT____Vtogcov__VA48_CAM_hit;
        CData/*0:0*/ TWE__DOT____Vtogcov__ras_out_addr_val_int;
        CData/*0:0*/ TWE__DOT____Vtogcov__ras_locked_int;
        CData/*0:0*/ TWE__DOT____Vtogcov__ras_write_active_int;
        CData/*0:0*/ TWE__DOT____Vtogcov__ras_empty_int;
        CData/*0:0*/ TWE__DOT____Vtogcov__ras_full_int;
        CData/*0:0*/ TWE__DOT____Vtogcov__DO_IDLE;
        CData/*0:0*/ TWE__DOT____Vtogcov__DO_LOCK;
        CData/*0:0*/ TWE__DOT____Vtogcov__DO_UNLOCK;
        CData/*0:0*/ TWE__DOT____Vtogcov__IS_KEY_MATCH;
        CData/*0:0*/ TWE__DOT____Vtogcov__IS_LOCKED;
        CData/*0:0*/ TWE__DOT____Vtogcov__IS_TLB_HIT;
        CData/*0:0*/ TWE__DOT____Vtogcov__NEXT_LEVEL;
        CData/*0:0*/ TWE__DOT____Vtogcov__START_TWE;
        CData/*0:0*/ TWE__DOT____Vtogcov__VA48_CAM_rd;
        CData/*0:0*/ TWE__DOT____Vtogcov__VA48_CAM_wr;
        CData/*3:0*/ TWE__DOT__VA48_CAM__DOT____Vtogcov__HEAD;
        CData/*3:0*/ TWE__DOT__VA48_CAM__DOT____Vtogcov__HEAD_PLUS_1;
        CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT____Vtogcov__STATE;
        CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT____Vtogcov__NEXT_STATE;
        CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT____Vtogcov__RAS_STACK_status;
        CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT____Vtogcov__RAS_STACK_wr;
        CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT____Vtogcov__RAS_STACK_rd;
        CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT____Vtogcov__RAS_STACK_empty;
        CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT____Vtogcov__RAS_STACK_full;
        CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT____Vtogcov__DO_IDLE;
        CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT____Vtogcov__DO_LOCK;
        CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT____Vtogcov__DO_UNLOCK;
        CData/*0:0*/ TWE__DOT__RAS16X48_K32__DOT____Vtogcov__IS_KEY_MATCH;
        CData/*3:0*/ TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT____Vtogcov__HEAD;
        CData/*3:0*/ TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT____Vtogcov__HEAD_PLUS_1;
        CData/*3:0*/ TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT____Vtogcov__HEAD_MINUS_1;
        CData/*0:0*/ __Vclklast__TOP__clk;
        CData/*0:0*/ __Vchglast__TOP__TWE__DOT__VA48_CAM_hit;
        SData/*15:0*/ TWE__DOT____Vtogcov__key;
        SData/*15:0*/ TWE__DOT__VA48_CAM__DOT____Vtogcov__compare;
        SData/*15:0*/ __Vfunc_TWE__DOT__VA48_CAM__DOT__compare_fcn__3__Vfuncout;
        IData/*31:0*/ TWE__DOT____Vtogcov__ras_key_int;
        WData/*71:0*/ TWE__DOT____Vtogcov__data_from_tlb[3];
        WData/*71:0*/ TWE__DOT____Vtogcov__VA48_CAM_rd_data[3];
        WData/*71:0*/ TWE__DOT____Vtogcov__VA48_CAM_wr_data[3];
        WData/*71:0*/ __Vtask_TWE__DOT__PUSH_VA48_CAM__1__write_data[3];
        WData/*71:0*/ __Vfunc_TWE__DOT__POP_VA48_CAM__2__Vfuncout[3];
        WData/*71:0*/ __Vfunc_TWE__DOT__POP_VA48_CAM__2__read_data[3];
        WData/*71:0*/ __Vfunc_TWE__DOT__VA48_CAM__DOT__read_fcn__4__Vfuncout[3];
        IData/*31:0*/ __Vfunc_TWE__DOT__VA48_CAM__DOT__read_fcn__4__unnamedblk3__DOT__i;
        QData/*47:0*/ TWE__DOT____Vtogcov__virt_addr_in;
        QData/*39:0*/ TWE__DOT____Vtogcov__data_from_memory;
        QData/*47:0*/ TWE__DOT____Vtogcov__pte_root_addr;
        QData/*47:0*/ TWE__DOT____Vtogcov__phys_addr_out;
        QData/*47:0*/ TWE__DOT____Vtogcov__data_to_memory;
    };
    struct {
        QData/*47:0*/ TWE__DOT____Vtogcov__ras_out_addr_int;
        QData/*47:0*/ TWE__DOT__RAS16X48_K32__DOT____Vtogcov__RAS_STACK_wr_data;
        QData/*47:0*/ TWE__DOT__RAS16X48_K32__DOT____Vtogcov__RAS_STACK_rd_data;
        QData/*47:0*/ __Vfunc_TWE__DOT__RAS16X48_K32__DOT__READ_RAS_STACK__6__Vfuncout;
        QData/*47:0*/ __Vchglast__TOP__TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_rd_data;
        CData/*0:0*/ __Vm_traceActivity[4];
    };
    
    // INTERNAL VARIABLES
    // Internals; generally not touched by application code
    VTWE__Syms* __VlSymsp;  // Symbol table
  private:
    // Coverage
    void __vlCoverInsert(uint32_t* countp, bool enable, const char* filenamep, int lineno, int column,
        const char* hierp, const char* pagep, const char* commentp, const char* linescovp);
  public:
    
    // CONSTRUCTORS
  private:
    VL_UNCOPYABLE(VTWE);  ///< Copying not allowed
  public:
    /// Construct the model; called by application code
    /// The special name  may be used to make a wrapper with a
    /// single model invisible with respect to DPI scope names.
    VTWE(const char* name = "TOP");
    /// Destroy the model; called (often implicitly) by application code
    ~VTWE();
    /// Trace signals in the model; called by application code
    void trace(VerilatedVcdC* tfp, int levels, int options = 0);
    
    // API METHODS
    /// Evaluate the model.  Application must call when inputs change.
    void eval() { eval_step(); eval_end_step(); }
    /// Evaluate when calling multiple units/models per time step.
    void eval_step();
    /// Evaluate at end of a timestep for tracing, when using eval_step().
    /// Application must call after all eval() and before time changes.
    void eval_end_step();
    /// Simulation complete, run final blocks.  Application must call on completion.
    void final();
    
    // INTERNAL METHODS
  private:
    static void _eval_initial_loop(VTWE__Syms* __restrict vlSymsp);
    void _traceDump();void _traceDumpOpen();void _traceDumpClose();public:
    void __Vconfigure(VTWE__Syms* symsp, bool first);
  private:
    static QData _change_request(VTWE__Syms* __restrict vlSymsp);
    static QData _change_request_1(VTWE__Syms* __restrict vlSymsp);
  public:
    static void _combo__TOP__2(VTWE__Syms* __restrict vlSymsp);
    static void _combo__TOP__6(VTWE__Syms* __restrict vlSymsp);
  private:
    void _configure_coverage(VTWE__Syms* __restrict vlSymsp, bool first) VL_ATTR_COLD;
    void _ctor_var_reset() VL_ATTR_COLD;
  public:
    static void _eval(VTWE__Syms* __restrict vlSymsp);
  private:
#ifdef VL_DEBUG
    void _eval_debug_assertions();
#endif  // VL_DEBUG
  public:
    static void _eval_initial(VTWE__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _eval_settle(VTWE__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _initial__TOP__5(VTWE__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _sequent__TOP__3(VTWE__Syms* __restrict vlSymsp);
    static void _sequent__TOP__4(VTWE__Syms* __restrict vlSymsp);
    static void _settle__TOP__1(VTWE__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _settle__TOP__7(VTWE__Syms* __restrict vlSymsp) VL_ATTR_COLD;
  private:
    static void traceChgSub0(void* userp, VerilatedVcd* tracep);
    static void traceChgTop0(void* userp, VerilatedVcd* tracep);
    static void traceCleanup(void* userp, VerilatedVcd* /*unused*/);
    static void traceFullSub0(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceFullTop0(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceInitSub0(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceInitTop(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    void traceRegister(VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceInit(void* userp, VerilatedVcd* tracep, uint32_t code) VL_ATTR_COLD;
} VL_ATTR_ALIGNED(VL_CACHE_LINE_BYTES);

//----------


#endif  // guard
