// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Design implementation internals
// See VTWE.h for the primary calling header

#include "VTWE.h"
#include "VTWE__Syms.h"

void VTWE::_eval(VTWE__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VTWE::_eval\n"); );
    VTWE* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->_combo__TOP__2(vlSymsp);
    vlTOPp->__Vm_traceActivity[1U] = 1U;
    if (((IData)(vlTOPp->clk) & (~ (IData)(vlTOPp->__Vclklast__TOP__clk)))) {
        vlTOPp->_sequent__TOP__3(vlSymsp);
        vlTOPp->__Vm_traceActivity[2U] = 1U;
    }
    if (((~ (IData)(vlTOPp->clk)) & (IData)(vlTOPp->__Vclklast__TOP__clk))) {
        vlTOPp->_sequent__TOP__4(vlSymsp);
        vlTOPp->__Vm_traceActivity[3U] = 1U;
    }
    vlTOPp->_combo__TOP__6(vlSymsp);
    // Final
    vlTOPp->__Vclklast__TOP__clk = vlTOPp->clk;
}

VL_INLINE_OPT QData VTWE::_change_request(VTWE__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VTWE::_change_request\n"); );
    VTWE* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    return (vlTOPp->_change_request_1(vlSymsp));
}

VL_INLINE_OPT QData VTWE::_change_request_1(VTWE__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VTWE::_change_request_1\n"); );
    VTWE* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    // Change detection
    QData __req = false;  // Logically a bool
    __req |= ((vlTOPp->TWE__DOT__VA48_CAM_hit ^ vlTOPp->__Vchglast__TOP__TWE__DOT__VA48_CAM_hit)
         | (vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_rd_data ^ vlTOPp->__Vchglast__TOP__TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_rd_data));
    VL_DEBUG_IF( if(__req && ((vlTOPp->TWE__DOT__VA48_CAM_hit ^ vlTOPp->__Vchglast__TOP__TWE__DOT__VA48_CAM_hit))) VL_DBG_MSGF("        CHANGE: TWE.sv:105: TWE.VA48_CAM_hit\n"); );
    VL_DEBUG_IF( if(__req && ((vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_rd_data ^ vlTOPp->__Vchglast__TOP__TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_rd_data))) VL_DBG_MSGF("        CHANGE: RAS.sv:59: TWE.RAS16X48_K32.RAS_STACK_rd_data\n"); );
    // Final
    vlTOPp->__Vchglast__TOP__TWE__DOT__VA48_CAM_hit 
        = vlTOPp->TWE__DOT__VA48_CAM_hit;
    vlTOPp->__Vchglast__TOP__TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_rd_data 
        = vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_rd_data;
    return __req;
}

#ifdef VL_DEBUG
void VTWE::_eval_debug_assertions() {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VTWE::_eval_debug_assertions\n"); );
    // Body
    if (VL_UNLIKELY((clk & 0xfeU))) {
        Verilated::overWidthError("clk");}
    if (VL_UNLIKELY((res_n & 0xfeU))) {
        Verilated::overWidthError("res_n");}
    if (VL_UNLIKELY((lock & 0xfeU))) {
        Verilated::overWidthError("lock");}
    if (VL_UNLIKELY((unlock & 0xfeU))) {
        Verilated::overWidthError("unlock");}
    if (VL_UNLIKELY((virt_addr_in & 0ULL))) {
        Verilated::overWidthError("virt_addr_in");}
    if (VL_UNLIKELY((virt_addr_in_vld & 0xfeU))) {
        Verilated::overWidthError("virt_addr_in_vld");}
    if (VL_UNLIKELY((data_from_memory & 0ULL))) {
        Verilated::overWidthError("data_from_memory");}
    if (VL_UNLIKELY((data_from_memory_vld & 0xfeU))) {
        Verilated::overWidthError("data_from_memory_vld");}
    if (VL_UNLIKELY((mode & 0xfcU))) {
        Verilated::overWidthError("mode");}
    if (VL_UNLIKELY((pte_root_addr & 0ULL))) {
        Verilated::overWidthError("pte_root_addr");}
}
#endif  // VL_DEBUG
